--[[
	MessageBoard - A World of Warcraft in-game forum
	Copyright (C) 2011  Darrell Keys

	This file is part of MessageBoard.

	MessageBoard is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	MessageBoard is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with MessageBoard.  If not, see <http://www.gnu.org/licenses/>.
]]


local Net=DuckLibMB.Net;

function MessageBoardXML:ShowAvatarWindow()
	MessageBoard_OFrame:Show();
	MessageBoard_OFrameTitle:Hide();
	MessageBoard_OFrame_Avatar:Show();
	self:ListAvailableAvatars();
	local _,avatar=self:ValidateBoardDB();
	local name=UnitName("player");
	if (not avatar or not avatar[name] or not avatar[name].Avatar) then return; end
	MessageBoard_OFrame_AvatarSel_CurrentIcon:SetTexture(avatar[name].Avatar);
end


function MessageBoardXML:SaveAvatar()
	local _,avatar=self:ValidateBoardDB(); if (not avatar) then return; end
	avatar[UnitName("player")]={};
	avatar[UnitName("player")].Avatar=MessageBoard_OFrame_AvatarSel_CurrentIcon:GetTexture();
    avatar[UnitName("player")].Stamp=time();
	DuckLibMB:Chat("Avatar saved");
	MessageBoard_OFrameTitle:Show();
	MessageBoard_OFrame_Avatar:Hide();
    MessageBoard_OFrame:Hide();
end


function MessageBoardXML:SelectIcon(self)
	 MessageBoard_OFrame_AvatarSel_CurrentIcon:SetTexture(_G[self:GetName().."Icon"]:GetTexture());
end

local ICON_PATH = GetMacroIcons( MACRO_ICON_FILENAMES );
function MessageBoardXML:ListAvailableAvatars()
	local IconCount=#GetMacroIcons(MACRO_ICON_FILENAMES);

	local icon,button;
	local index;

	local max=0;
	if (IconCount<=21) then max=0; else max=math.ceil(IconCount)-14; end
	MessageBoard_OFrame_AvatarSlider:SetMinMaxValues(0,max);
	local offset=MessageBoard_OFrame_AvatarSlider:GetValue();

	-- Icon list
    for i=1,21 do
        icon=_G["MessageBoard_OFrame_AvatarSel_"..i.."Icon"];
        button=_G["MessageBoard_OFrame_AvatarSel_"..i];
        if (not icon or not button) then return; end
        index=i+offset;
        if (index<=#GetMacroIcons(MACRO_ICON_FILENAMES)) then
			icon:SetTexture("Interface\\Icons\\" .. ICON_PATH[index]);
            button:Show();
        else
            button:Hide();
        end
    end 
end