MessageBoardXML.Editor.ID=nil;
MessageBoardXML.Editor.Goal=nil;
MessageBoardXML.Editor.Level=nil;
local Quotedmsg=nil;

function MessageBoardXML.Editor:OnLoad(self)
	tinsert(UISpecialFrames,"MessageBoard_Editor");
end

function MessageBoardXML.Editor:Init(id,topic,message,goal,level)
	Quotedmsg=message;

	self.ID=id;
	self.Goal=goal;
	if (not level) then level=0; end
	self.Level=level;
	if (not topic) then MessageBoard_EditorTopicLabel:Hide(); MessageBoard_EditorTopicName:Hide(); MessageBoard_Editor_Announce:Hide(); MessageBoard_Editor_Sticky:Hide(); MessageBoard_Editor_Locked:Hide(); MessageBoard_Editor_Quote:Hide();
	else
		MessageBoard_EditorTopicLabel:Show(); MessageBoard_EditorTopicName:Show(); MessageBoard_EditorTopicName:SetText(topic);
		-- only allow admins to set stickies,announcements,and locked posts -- 
		if (MBAdministrator) then
		MessageBoard_Editor_Announce:Show(); MessageBoard_Editor_Sticky:Show(); MessageBoard_Editor_Locked:Show();
		else MessageBoard_Editor_Announce:Hide(); MessageBoard_Editor_Sticky:Hide(); MessageBoard_Editor_Locked:Hide();	end
	end
	
	if MessageBoard_LS.Quoted==true then MessageBoard_Editor_Quote:SetChecked(true); end
	if MessageBoard_LS.Quoted==false then MessageBoard_Editor_Quote:SetChecked(false); message="" ;end
	
	if (not message) then message=""; end
	
	MessageBoard_EditorSBEdit:SetText(message);
	MessageBoard_Editor_Announce:SetChecked(false);
	MessageBoard_Editor_Sticky:SetChecked(false);
	MessageBoard_Editor_Locked:SetChecked(false);

	if (self.Level>=21) and (self.Level<=29) then MessageBoard_Editor_Announce:SetChecked(true);
	elseif (self.Level>=11) and (self.Level<=19) then MessageBoard_Editor_Sticky:SetChecked(true);
	elseif (self.Level>=31) and (self.Level<=39) then MessageBoard_Editor_Locked:SetChecked(true);
	end

	MessageBoard_EditorSBEdit:SetCursorPosition(0);
	MessageBoard_EditorTopicName:SetCursorPosition(0);
	MessageBoard_Editor:Show();	
end

function MessageBoardXML.Editor:CheckClick(self)
	if (self==MessageBoard_Editor_Announce) then
		MessageBoard_Editor_Sticky:SetChecked(false);
		MessageBoard_Editor_Locked:SetChecked(false);
	end
	if (self==MessageBoard_Editor_Sticky) then
		MessageBoard_Editor_Announce:SetChecked(false);
		MessageBoard_Editor_Locked:SetChecked(false);
	end
	if (self==MessageBoard_Editor_Locked) then
		MessageBoard_Editor_Announce:SetChecked(false);
		MessageBoard_Editor_Sticky:SetChecked(false);		
	end
	if MessageBoardXML.Editor.ID==3 then
		if (MessageBoard_Editor_Quote:GetChecked()) then
			local mycurrenttext=nil;
			local newmsg=nil;
			mycurrenttext=MessageBoard_EditorSBEdit:GetText();
			newmsg=mycurrenttext..Quotedmsg;
			MessageBoard_EditorSBEdit:SetText(newmsg); MessageBoard_EditorSBEdit:SetCursorPosition(0);	
		else
			local mycurrenttext=nil;
			local newmsg="";
			MessageBoard_EditorSBEdit:SetText(newmsg); MessageBoard_EditorSBEdit:SetCursorPosition(0);
		end
	end
end


-- Get data from a textual link for display
-- TODO: Implement server data pull for local cache (maybe)
function MessageBoardXML.Editor:GetItemLink(itemID)
	if (not itemID) then return nil; end
	itemName,itemLink,itemRarity,itemLevel,itemMinLevel,itemType,itemSubType,itemStackCount,itemEquipLoc,itemTexture=GetItemInfo(itemID);
	return itemLink;
end


function MessageBoardXML.Editor:ItemDrop(editor)
	item,itemID,link=GetCursorInfo();
	ClearCursor();
	if (not link) then return; end
	if (editor) then
		MessageBoard_EditorSBEdit:Insert(self:GetItemLink(link).."|cff888888");
		return;
	end
end


function MessageBoardXML.Editor:Save()
	local topic=MessageBoard_EditorTopicName:GetText();

	if (MessageBoard_Editor_Announce:GetChecked()) then self.Level=20 + CategoryLevel;
	elseif (MessageBoard_Editor_Sticky:GetChecked()) then self.Level=10 + CategoryLevel;
	elseif (MessageBoard_Editor_Locked:GetChecked()) then self.Level=30 + CategoryLevel;
	else self.Level=0 + CategoryLevel; end
	if (type(self.ID)=="function") then
		self.ID(self,topic,MessageBoard_EditorSBEdit:GetText(),self.Goal,self.Level);
	else
		if (self.ID==MessageBoardXML.Editor.ID_NEWTOPIC and (not topic or topic=="")) then return; end
		MessageBoardXML:EditedText(self.ID,topic,MessageBoard_EditorSBEdit:GetText(),self.Goal,self.Level);
	end
	
	MessageBoard_Editor:Hide();
	MessageBoardXML:ViewTopics()
end


function MessageBoardXML.Editor:Discard()
	MessageBoard_Editor:Hide();
	--MessageBoardXML:ViewTopics()
end


  -- Hook the container buttons
    local containerFunc = function(button)
        if IsShiftKeyDown() then
            if MessageBoard_EditorSBEdit:HasFocus() then
                MessageBoard_EditorSBEdit:Insert(GetContainerItemLink(button:GetParent():GetID(), button:GetID()))
             end
        end
    end

    hooksecurefunc("ContainerFrameItemButton_OnModifiedClick", containerFunc)
	
local function spellFunc(self, button)
   if IsShiftKeyDown() then
      local offset
      local page
      if SpellBookFrame.bookType == BOOKTYPE_PET then
	 offset = 0
	 page = SPELLBOOK_PAGENUMBERS[BOOKTYPE_PET]
      else
	 offset = SpellBookFrame.selectedSkillLineOffset
	 page = SPELLBOOK_PAGENUMBERS[SpellBookFrame.selectedSkillLine]
      end
      local sid = self:GetID() + offset + (SPELLS_PER_PAGE*(page - 1))
      if MessageBoard_EditorSBEdit:HasFocus() then
	 MessageBoard_EditorSBEdit:Insert(GetSpellLink(sid, SpellBookFrame.bookType))
      end
   end
end

hooksecurefunc("SpellButton_OnModifiedClick", spellFunc)
	
local origContainerFunc = ContainerFrameItemButton_OnModifiedClick
function ContainerFrameItemButton_OnModifiedClick(...)
   local args = {...}
   local self = args[1]
   if IsShiftKeyDown() then      
      if MessageBoard_EditorSBEdit:HasFocus() then
	 local id = self:GetID()
	 local pid = self:GetParent():GetID()
	 local link = GetContainerItemLink(pid, id)
	 MessageBoard_EditorSBEdit:Insert(link)
	 return nil
      end
   end
   return origContainerFunc(...)
end

local origBankFunc = BankFrameItemButtonGeneric_OnModifiedClick
function BankFrameItemButtonGeneric_OnModifiedClick(...)
   local args = {...}
   local self = args[1]
   if IsShiftKeyDown() then
      if MessageBoard_EditorSBEdit:HasFocus() then
	 local id = self:GetID()
	 local link = GetContainerItemLink(BANK_CONTAINER, id)
	 MessageBoard_EditorSBEdit:Insert(link)
	 return nil
      end
   end
   return origBankFunc(...)
end

local origDollFunc = PaperDollItemSlotButton_OnModifiedClick
function PaperDollItemSlotButton_OnModifiedClick(...)
   local args = {...}
   local self = args[1]
   if IsShiftKeyDown() then
      if MessageBoard_EditorSBEdit:HasFocus() then
	 local id = self:GetID()
	 local link = GetInventoryItemLink("player", id)
	 MessageBoard_EditorSBEdit:Insert(link)
	 return nil
      end
   end
   return origDollFunc(...)
end

local origInboxFunc = InboxFrame_OnModifiedClick
function InboxFrame_OnModifiedClick(...)
   local args = {...}
   local self = args[1]
   if IsShiftKeyDown() then
      if MessageBoard_EditorSBEdit:HasFocus() then
	 local id = self:GetID()
	 local link = GetInboxItemLink(InboxFrame.openMailID, id)
	 MessageBoard_EditorSBEdit:Insert(link)
	 return nil
      end
   end
   return origInboxFunc(...)
end

local origMerchantFunc = MerchantItemButton_OnModifiedClick
function MerchantItemButton_OnModifiedClick(...)
   local args = {...}
   local self = args[1]
   if IsShiftKeyDown() then
      if MessageBoard_EditorSBEdit:HasFocus() then
	 local id = self:GetID()
	 local link = GetMerchantItemLink(id)
	 MessageBoard_EditorSBEdit:Insert(link)
	 return nil
      end
   end
   return origMerchantFunc(...)
end

local origHyperLinkFunc = ChatFrame_OnHyperlinkShow
function ChatFrame_OnHyperlinkShow(...)
   local args = {...}
   local self = args[1]
   local linktext = args[3]
   if IsShiftKeyDown() then
      if MessageBoard_EditorSBEdit:HasFocus() then
	 MessageBoard_EditorSBEdit:Insert(linktext)
	 return nil
      end
   end
   return origHyperLinkFunc(...)
end